//---------------------------------------------------------------------------
// MiniTester.cpp
// 
// Written by:   ????
// Last Updated: ?????
//
// This program can be command line compiled using the following:
// g++ ______    ______    [enter]
//
// Suggest filling in the above blanks for practice
//
// Hint put all the .cpp filenames including the .cpp extension
//      after the g++ separated by spaces
// Example:  g++ MiniFuncs.cpp MiniTester.cpp  <-- this could be the answer
//
// Description
// Main function used to test 
// a MiniStack templated class as declared and defined in MiniStack.h
//
// Makes use of tester functions defined in MiniFuncs.cpp
//
// This file is mostly for the student's own testing use.
//
// The instructor will likely use his/her own tester program
// to test the MiniStack class AND the miniFuncs.cpp functions
//
//---------------------------------------------------------------------------
#include <iostream>         // Provides cin, cout
#include "MiniFuncs.h"
#include "MiniStack.h"

using namespace std;        // Use C++ Standard namespace

//---------------------------------------------------------------------------
// ProtoTypes for test functions
//---------------------------------------------------------------------------
int StudentStarterTest();


//---------------------------------------------------------------------------
// main function - it all begins here
//---------------------------------------------------------------------------
int main()
{	
   cout << "Begin MiniTester.cpp" << endl;
   
   StudentStarterTest();
   
   return 0;   // zero indicates program success to operating system
}

//---------------------------------------------------------------------------
// StudentStarterTest
//---------------------------------------------------------------------------
int StudentStarterTest()
{
	cout << "Begin StudentStarterTest...\n";
	
    //------------------------------------------------------
    // The following is a beginning to test stuff
    // but needs a lot of work...
    //------------------------------------------------------
	
	// Test the stack constructor with type char
	MiniStack<char> s1;
	
	// Test the push function
	s1.push('a');
	cout << endl;
	
	// Test other MiniStack stuff
	
	// Test isPalindrome
    // Call isPalindrome method to test your code
	cout << endl<< "Is radar a palindrome? " << isPalindrome("radar");
	cout << endl;

	cout << endl<< "Is happy a palindrome? " << isPalindrome("happy");
	cout << endl;

	cout << endl<< "Is 'do wah ditty' a palindrome? " << isPalindrome("do wah ditty");
	cout << endl;

	cout << endl<< "Is 'no sam mason' a palindrome? " << isPalindrome("no sam mason");
	cout << endl;

	// Test balancedParentheses
	// Call balancedParentheses method to test it
	cout << endl;
	cout << "BalanceParen true test returns: " << balancedParentheses( "(()( ) )" );
	cout << endl;
	cout << "BalanceParen false test returns: " << balancedParentheses( "((()( ) )" );
	cout << endl;
	
	// Test balancedBlocks
	// Call balancedBlocks to test
	cout << endl;
	cout << "Balanced Block true test returns: ";
	cout << balancedBlocks( "{ if(a<b){ return true; } }" );
	cout << endl;
	cout << "Balanced Block false test returns: ";
	cout << balancedBlocks( "{ if(a<b){ g[i] = 5; return (true; } }" );
	cout << endl;

    // Do this one last --- if it fails things will crash
    //MiniStack<double> errS;
    //try
    //{
       //errS.top();
    //}
    //catch (underflowError e)
    //{
	    //cout << "error caught\n" << e.what() << endl;
    //}

	cout << "... StudentStarterTest Ends\n";

    return 0;   // shouldn't there be a point count or something here?
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// end file

